#ifndef AX_ALK_H__
#define AX_ALK_H__
/*-------------------------------------------------------------------------*/

/*
	
	Alice Soft archive (*.ALK) (C)Alice Soft
	Susie Plug-in

*/

/*-------------------------------------------------------------------------*/

#include "SpiBase.h"
	
/* wb_̍\
 * wb_ *
	uint32 ID;			// ALKx (x = 0)
	uint32 fileCount:	// t@C

 * t@C *
	uint32 offset;		// ItZbg
	uint32 fileSize;	// t@CTCY
**/

/*-------------------------------------------------------------------------*/

class SpiALK : public SpiBase
{
private:
	static const DWORD m_id	= 0x004B4C41;	// ALKx (x = 0...)

#pragma pack(1)
	struct ALKInfo
	{
		DWORD offset;
		DWORD fileSize;
	};
#pragma pack()

public:
	/// <summary>Ήt@CmF</summary>
	/// <param name="data">2KB obt@</param>
	/// <param name="extension">gqBȂׂgȂ</param>
	/// <returns>1: ΉA0: Ή</returns>
	static int IsSupported(BYTE* data, LPCSTR extension)
	{
		return (*reinterpret_cast<DWORD*>(data) & 0x00FFFFFF) == m_id;
	}

	/// <summary>t@C̃Zbg</summary>
	int SetFileInfo(fileInfo& info, AutoFile& file, DWORD id, DWORD fileNumber)
	{
		DWORD read;
		DWORD buffer[2];
		if (file.Seek((fileNumber << 3) + 8, FILE_BEGIN) == INVALID_SET_FILE_POINTER || !file.Read(buffer, 8, &read))
			return SPI_FILE_READ_ERROR;

		*reinterpret_cast<DWORD*>(info.method)	= id;	// ALK
//		info.method[4] = '\0';
//		info.path[0]	= '\0';
		info.position	= (fileNumber + 1) * 8;
		info.filesize	= buffer[1];
		info.compsize	= buffer[1];

		// t@CȂBĂƂɕt
		int i;
		if (fileNumber < 100000)	i = 5;
		else if (fileNumber < 1000000)	i = 6;
		else if (fileNumber < 10000000)	i = 7;
		else if (fileNumber < 100000000)	i = 8;
		else if (fileNumber < 1000000000)	i = 9;
		else i = 10;

		lstrcpyn(info.filename, "alk", 16);
		int n = fileNumber;
		for (int j = 0;j < i;j++)
		{
			info.filename[2 + i - j] = n % 10 + '0';
			n /= 10;
		}
		info.filename[3 + i] = '\0';

		// t@C^Cv̐
		// Ƃ肠AQNTJPĜ݁B
		if (file.Seek(buffer[0], FILE_BEGIN) == INVALID_SET_FILE_POINTER || !file.Read(buffer, 8, &read))
			return SPI_FILE_READ_ERROR;

		if (buffer[0] == 0x00544E51)
		{
			// "QNT"
			lstrcat(info.filename, ".qnt");
		}
		else if (static_cast<USHORT>(buffer[0]) == 0xD8FF && (buffer[1] >> 16) == 0x464A)
		{
			// "JFIF'
			lstrcat(info.filename, ".jpg");
		}
		else
		{
			// ̑
			lstrcat(info.filename, ".bin");
		}
		return SPI_ALL_RIGHT;
	}

	// src memory

	/* ͎͂ȂBftHg̎ɔC */

	// src File
/*-------------------------------------------------------------------------*/
/* [t@C]A[JCûׂẴt@C̏擾 */
	int GetArchiveInfo(LPSTR src, DWORD offset, HLOCAL *lphInf)
	{
		SpiTrace("SpiALK::GetArchiveInfo\n");

		// t@CJ
		AutoFile srcFile;
		DWORD read;
		DWORD buffer[2];
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE || !srcFile.Read(buffer, 8, &read))
			return SPI_FILE_READ_ERROR;
		if ((buffer[0] & 0x00FFFFFF) != m_id)
			return SPI_NOT_SUPPORT;
		DWORD fileCount	= buffer[1];

#ifdef	_DEBUG
		if (static_cast<BYTE>(buffer[0]  >> 24) != '0')
		{
			char text[16] = "unknown type: ";
			lstrcat(text, (char*)&buffer[0]);
			MessageBox(NULL, text, src, MB_ICONINFORMATION);
			return SPI_NOT_SUPPORT;
		}
#endif

		// m
		LocalHeap lhInfo;
		fileInfo* pInfo	= reinterpret_cast<fileInfo*>(lhInfo.Alloc(fileCount * sizeof(fileInfo) + 1));
		if (pInfo == NULL)
			return SPI_NO_MEMORY;

		// t@C̎擾
		for (DWORD i = 0;i < fileCount;i++)
		{
			int result = SetFileInfo(pInfo[i], srcFile, buffer[0], i);
			if (result != SPI_ALL_RIGHT)
			{
				return result;
			}
		}
		*lphInf	= lhInfo.Detach();
		return SPI_ALL_RIGHT;
	}

/*-------------------------------------------------------------------------*/
/* [t@C]A[JCu̎w肵t@C̏擾 */
	int GetFileInfo(LPSTR src, DWORD offset, LPSTR filename, bool bCompareNoCase, fileInfo *lpInfo)
	{
		SpiTrace("SpiALK::GetFileInfo\n");

		// t@CJ
		AutoFile srcFile;
		DWORD read;
		DWORD buffer[2];
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE || !srcFile.Read(buffer, 8, &read))
			return SPI_FILE_READ_ERROR;
		if ((buffer[0] & 0x00FFFFFF) != m_id)
			return SPI_NOT_SUPPORT;
		DWORD fileCount	= buffer[1];

		// 啶E̋
		int (WINAPI *cmpFunc)(LPCSTR, LPCSTR)	= lstrcmpi;	// 啶E𓯈ꎋ
		if (!bCompareNoCase)
			cmpFunc = lstrcmp;	// 啶E

		// t@C̎擾
		fileInfo info	= {0};
		for (DWORD i = 0;i < fileCount;i++)
		{
			int result = SetFileInfo(info, srcFile, buffer[0], i);
			if (result != SPI_ALL_RIGHT)
			{
				return result;
			}
			if (!cmpFunc(info.filename, filename))
			{
				*lpInfo	= info;
				return SPI_ALL_RIGHT;
			}
		}
		return SPI_NOT_SUPPORT;
	}

/*-------------------------------------------------------------------------*/
/* [t@C]A[JCũt@C𒊏o */
	int GetFile(LPSTR src, DWORD offset, LPSTR dest, bool bDestMemory, SPI_CALLBACK prgressCallback, long lData)
	{
		SpiTrace("SpiALK::GetFile\n");

		// t@CJ
		AutoFile srcFile;
		if (srcFile.Open(src) == INVALID_HANDLE_VALUE)
			return SPI_FILE_READ_ERROR;

		// t@C̎擾
		fileInfo info;
		int result = SetFileInfo(info, srcFile, 0, (offset >> 3) - 1);
		if (result != SPI_ALL_RIGHT)
		{
			return result;
		}

		// ̊m
		LocalHeap lhImage;
		void* pImage	= lhImage.Alloc(info.filesize ? info.filesize : 4, LMEM_MOVEABLE);
		if (pImage == NULL)
			return SPI_NO_MEMORY;

		// t@CC[W̓Ǎ
		DWORD read;
		if (srcFile.Seek(-8) == INVALID_SET_FILE_POINTER
			|| !srcFile.Read(pImage, info.filesize, &read))
		{
			return SPI_FILE_READ_ERROR;
		}

		if (bDestMemory)
		{
			/* o */
			HLOCAL *phMem = reinterpret_cast<HLOCAL*>(dest);
			*phMem = lhImage.Detach();
		} else {
			/* t@Co */
			char destPath[MAX_PATH];
			lstrcpy(destPath, dest);
			lstrcat(destPath, "\\");
			lstrcat(destPath, info.filename);
			AutoFile destFile;
			if (destFile.Open(destPath, false) == INVALID_HANDLE_VALUE)
				return SPI_FILE_WRITE_ERROR;

			DWORD written;
			if (!destFile.Write(pImage, info.filesize, &written))
				return SPI_FILE_WRITE_ERROR;
		}
		return SPI_ALL_RIGHT;
	}
};

#endif	// AX_ALK_H__